<template>
    <div class="base-btn" @click.prevent="state.opt = !state.opt">
        <div class="has-opt">
            <div class="btn-wrap bg-prime txt-full-white br22">
                <div class="icon-case">
                    <layout-icon size="icon-25"/>
                </div>
            </div>
            <transition name="slide-fade">
                <div class="over-list bg-night-light br10" v-if="state.opt === true">
                    <template v-for="item in list" :key="item.list">
                        <div class="item-case centered txt-full-white hover-prime-light br10"
                        @click.prevent="item.fn">
                            {{ item.name }}
                        </div>
                    </template>
                </div>
            </transition>
        </div>
    </div>
</template>

<script setup lang="ts">
import { reactive } from 'vue';
import { useRouter } from 'vue-router';
import langStore from '../store/langStore';
import photoStore from '../store/photoStore';
import LayoutIcon from './icons/LayoutIcon.vue';

const { isLang } = langStore;
const { push } = useRouter();
const { clAll, clPay, clPor, getPhotos } = photoStore;

const state = reactive({
    opt: false
})

async function showPor(): Promise<void> {
    getPhotos.value.isLoading = true;
    try {
        const ret = await clPor();
        window.scrollTo(0, 0);
        if (!ret) {
            throw new Error('nouvelle grille non tranmise');
        }
        getPhotos.value.list = ret;
        getPhotos.value.isLoading = false; 
    } catch(err: any) {
        console.log(err);
    } finally {
        push('/nos-photos/portrait');
    }
}

async function showPay(): Promise<void> {
    getPhotos.value.isLoading = true;
    try {
        const ret = await clPay();
        window.scrollTo(0, 0);
        if (!ret) {
            throw new Error('nouvelle grille non tranmise');
        }
        getPhotos.value.list = ret;
        getPhotos.value.isLoading = false; 
    } catch(err: any) {
        console.log(err);
    } finally {
        push('/nos-photos/paysage');
    }
}
async function showAll(): Promise<void> {
    getPhotos.value.isLoading = true;
    try {
        const ret = await clAll();
        window.scrollTo(0, 0);
        if (!ret) {
            throw new Error('nouvelle grille non tranmise');
        }
        getPhotos.value.list = ret;
        getPhotos.value.isLoading = false; 
    } catch(err: any) {
        console.log(err);
    } finally {
        push('/nos-photos/tous');
    }
}

const list = [
    {id: 1 , name: isLang.value.photos.layout.lay1, fn: showAll},
    {id: 2 , name: isLang.value.photos.layout.lay2, fn: showPay},
    {id: 3 , name: isLang.value.photos.layout.lay3, fn: showPor},
]


</script>

<style scoped>
.base-btn {
    margin: 0;
    position: fixed;
    bottom: 20px;
    right: 20px;
    z-index: 5000;
}
.has-opt {
    position: relative;
}


.over-list {
    margin: 0;
    position: absolute;
    right: 40px;
    bottom: 40px;
    width: 150px;
    box-shadow: 2px 2px 5px #2525257e;
}
.item-case {
    margin: 0;
    width: 100%;
    height: 40px;
    cursor: pointer
}

/*version mobile et tablette seulement 0 - 1023px */
@media (max-width: 1023px) {
    .over-list {
    margin: 0;
    position: absolute;
    width: 150px;
}
}
</style>